package com.accenture.techlabs.assist.jpetstore;
import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;
import org.apache.jmeter.DynamicClassLoader;
import org.apache.jmeter.JMeter;
import org.apache.jmeter.NewDriver;
import org.apache.log4j.Logger;

import com.accenture.techlabs.assist.profile.ProfRepository;

import forepost.ProfileAnalyzer;


public class ForePostAnalyzerScript {
	
	// QI
	private static final Logger logger = Logger.getLogger(ForePostAnalyzerScript.class);
	
	private static ForePostAnalyzerScript instance = new ForePostAnalyzerScript();
	
	public static void startup()
	{
		try
		{
			try {
						ProfileAnalyzer analyzer = new ProfileAnalyzer("C:\\Research\\workspace_AFOCMS\\JMeterScript");
			      		URLClassLoader sysloader = (URLClassLoader)ClassLoader.getSystemClassLoader();
			            Class sysclass = URLClassLoader.class;
			            Method method = sysclass.getDeclaredMethod("addURL",new Class[]{URL.class});
			            method.setAccessible(true);
			            method.invoke(sysloader,new Object[]{ (new File(System.getProperty("user.dir") + File.separator + "exlibs" + File.separator + "weka.jar")).toURL() }); 
			            method.invoke(sysloader,new Object[]{ (new File(System.getProperty("user.dir") + File.separator + "exlibs" + File.separator + "AbsoluteLayout.jar")).toURL() });
			            method.invoke(sysloader,new Object[]{ (new File(System.getProperty("user.dir") + File.separator + "exlibs" + File.separator + "swing-layout-1.0.jar")).toURL() });
			            method.invoke(sysloader,new Object[]{ (new File(System.getProperty("user.dir") + File.separator + "exlibs" + File.separator + "AppFramework-1.03.jar")).toURL() });            
			            method.invoke(sysloader,new Object[]{ (new File(System.getProperty("user.dir") + File.separator + "exlibs" + File.separator + "fastica-1.11.jar")).toURL() });            
			      
			            //QI
//			            System.out.println(System.getProperty("user.dir") + File.separator + "exlibs" + File.separator + "weka.jar");
			            
			            
			            //StartAnalyzer();
//			            logger.info("startGUI!");//QI
			      analyzer.startGUI();
			     } catch (Exception e) {
			      e.printStackTrace();
			     }
		}
		catch(Exception e)
		{
			System.out.println("Exception in JMeterScript");
			e.printStackTrace();
		}
	}
			 
}



