package forepost;

import forepost.utilities.*;
import java.util.*;
import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class ForePostRuleClassifierTest {
	ForePostRuleClassifier jrip = null;

	@Before
	public void setUp() throws Exception {
		jrip = new ForePostRuleClassifier ("C:\\Program Files\\Weka-3-7\\data\\vote.arff");
	}

	@After
	public void tearDown() throws Exception {
		jrip = null;
	}

	@Test
	public void testClassify() {
		boolean ret;
		try {
			ret = jrip.Classify();
			assertTrue(ret);
			Rules rules = jrip.ProcessRules();
			Iterator<Rule> it = rules.iterator();
			while(it.hasNext()){
				Rule rule = it.next();
				System.out.println("Class: " + rule.GetRuleClass() );
				Iterator<Term> it1 = rule.iterator();
				while( it1.hasNext()){
					Term term = it1.next();
					assertNotNull("widget name is null", term.getInputName());
					System.out.println(term.getInputName() + ": " + term.getStrValue() );
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			assertTrue(false);
		}
	}
}
