package forepost;

public class MethodCall {
	Method method = null;
	
	long start = 0;
	long end = 0;
	long runningtime = 0;
	long elapsedtime = 0;
	long elapsed4CallTree = 0;
	String threadId = null;
	MethodCall parent = null;
//	Vector<MethodCall> Children = new Vector<MethodCall>();
	
	public MethodCall( long sTime, String thread, Method m ) {
		start = sTime;
		threadId = thread;
		method = m;
	}

//	public void AddChild( MethodCall methcall ) {
//		if( methcall != null ) {
//			Children.add(methcall);
//		}
//	}
	
//	public void AddParent( MethodCall methcall )
//	{
//		if( methcall != null ) {
//			parent = methcall;
//		}
//	}
	
	public void Finish( long eTime ) {
		end = eTime;
		elapsedtime = end - start;
		runningtime = elapsedtime - elapsed4CallTree;
		if( runningtime < 0 )
			runningtime = 0;
		if( method != null ){
			method.AddElapsedTime( runningtime );
			
		}
	}
	
	
	public Method getMethod() {
		return method;
	}

	public long getElapsedTime() {
		return elapsedtime;
	}
	public long getRunningTime() {
		return runningtime;
	}

//	public void PrintChildren(MethodCall mec, int indent){
//		if( mec == null )
//			return;
//		if(mec.Children.size()>0){
//			System.out.println("This method spawns " + String.valueOf(Children.size()) + " method calls" );
//		}
//		for( int i = 0; i < mec.Children.size(); i++ ) {
//			MethodCall mc = mec.Children.elementAt(i);
//			if( mc != null ){
//				for( int j = 0; j < indent; j++ ){System.out.print(" ");}
//				System.out.println("Spawned " + mc.method.getName() );
//				PrintChildren(mc, indent+2);
//			}			
//		}		
//	}

	public void ElapsedTime4CallTree(long elapsed2) {
		elapsed4CallTree += elapsed2;
	}
}
