package forepost;
public interface ProfileStatistics {
	public enum ProcessingStatus {
	    WAITING, PAUSED, STOPPED, PROCESSING, TRANSITIONING 
	}
	public int GetMethods() throws Exception;
	public int GetInvocations() throws Exception;
	public double GetElapsedTime() throws Exception;
	public int GetThreads() throws Exception;
	public int GetAttributes() throws Exception;
	public int GetDatalen() throws Exception;
}
