package forepost;

import java.util.*;

public class ScreenInputValues
{
	private HashMap<String, HashMap<String, ArrayList<String>>> TheMap = new HashMap<String, HashMap<String, ArrayList<String>>>();
	
	public HashMap<String, HashMap<String, ArrayList<String>>> getTheMap() {
		return TheMap;
	}

	private HashMap<String, ArrayList<String>> MapInputValue = null;
	private ArrayList<String> Values = null;
	
	public ScreenInputValues()
	{
	}
	
	public void AddNewValue( String screen, String input, String value ) throws Exception
	{
		if( screen == null || input == null || value == null ) return;
		
		screen = screen.toLowerCase();
		input = input.toLowerCase();
		
		if( input.toLowerCase().endsWith("unselected") ){
			input = input.toLowerCase();
			int ind = input.indexOf("unselected");
			input = input.substring(0, ind);
		}
/*		
		if( screen.compareToIgnoreCase("optionsendorsements") == 0 && input.compareToIgnoreCase("adultfamilyhome") == 0 ){
			int ii;
			ii = 5;
		}
*/
		if( TheMap.containsKey(screen) ){
			MapInputValue = TheMap.get(screen);
			if( MapInputValue == null )
				throw new Exception("Map object for inputs to values is null");
			if( MapInputValue.containsKey(input) ){
				Values = MapInputValue.get(input);
				if( Values == null )
					throw new Exception("Values object is null");
				Iterator<String> itVal = Values.iterator();
				boolean found = false;
				while(itVal.hasNext()){
					if( value.compareToIgnoreCase(itVal.next()) == 0 ){
						found = true;
						break;
					}
				}
				if( !found ) Values.add(value);
			}
			else
			{
				Values = new ArrayList<String>();
				Values.add(value);
				MapInputValue.put(input, Values);
			}
		}
		else
		{
			Values = new ArrayList<String>();
			MapInputValue = new HashMap<String, ArrayList<String>>();
			MapInputValue.put(input, Values);
			TheMap.put(screen, MapInputValue);
		}
	}
}
