package forepost;
import javax.swing.JFrame;
import javax.swing.table.DefaultTableModel;

import java.util.LinkedList;
import java.util.Vector;

import org.apache.jmeter.NewDriver;
import org.apache.log4j.Logger;
import org.jdesktop.application.Application;



public class startGUI implements Runnable
{
	// QI
	private static final Logger logger = Logger.getLogger(startGUI.class);
	
	ProfileAnalyzer analyzer = null;
	FOREPOSTView fv = null;
	
	
	public startGUI( ProfileAnalyzer pp ) throws Exception{
		if( pp == null ) throw new Exception("the analyzer object is null");
		analyzer = pp;
	}
	 
     public void run()
     {
        System.out.print("Running the Test Thread\n");
//        logger.info("srartGUI run!"); //QI
        try{
//         ProfileAnalyzer pp = new ProfileAnalyzer(FPUtility.getRepository());
         fv = new FOREPOSTView(Application.getInstance(FOREPOSTApp.class),analyzer); 
         
         //1. Create the frame.
         JFrame frame = new JFrame("FrameDemo");
         frame.setBounds(0, 0, 900, 500);
        // frame.setUndecorated(true);
         //frame.getGraphicsConfiguration().getDevice().setFullScreenWindow(frame);
        // jframe.getGraphicsConfiguration().getDevice().setFullScreenWindow(jframe);
         frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

         //2. Create components and put them in the frame.
         
          frame.setContentPane(fv.getRootPane());
          
            
         //3. Show it.
         frame.setVisible(true);
         
         //statsDisplay(fv);
        } 
        catch(Exception e)
        {
        	e.printStackTrace();	
        }
  
//        SetRuleInfo( true,"(a < b)", "good" );
//        SetRuleInfo( true,"(a > b)", "bad" );
        //test calls to add rows to the table
//        SetProfileInfo( 1, 1.0, 2, 3, 4, 5 );       
//        SetProfileInfo( 2, 1.0, 6, 7, 8, 9 );
//        SetProfileInfo( 3, 1.0, 6, 7, 8, 9 );
        
    }

     public void setClassList(){
    	//System.out.print(fv.getAnalyzer().getClasses().toArray());
    	fv.configClassificationClassList.setListData(fv.getAnalyzer().getClasses().toArray());
    	 LinkedList classList = new LinkedList();
    	 classList = fv.getAnalyzer().getClasses();
    	 for(int i=0;i<classList.size();i++){
    	 fv.combo.addItem(classList.get(i));
    	 }
    	
       }
     
     public void SetProfileInfo( int profNo, double elapsedtime, int methods, int invocations, int attr, int data ){
     	javax.swing.table.DefaultTableModel profileTableModel =  fv.getProfileTableModel();
     	if( profileTableModel != null ){
     		profileTableModel.addRow(new Object[]{String.valueOf(profNo), String.valueOf(elapsedtime), String.valueOf(methods), String.valueOf(invocations), String.valueOf(attr), String.valueOf(data), FPUtility.UNASSIGNEDCLASS, false});
//     		ClassComboBox cb = (ClassComboBox)profileTableModel.getValueAt(profileTableModel.getRowCount()-1, 6 );
//     		System.out.println(cb);
     	}
     	
     }

     public void SetRuleInfo( boolean Active, String ruleTxt, String Class ){
      	javax.swing.table.DefaultTableModel ruleTableModel =  fv.getRuleTableModel();
      	if( ruleTableModel != null ){
      		ruleTableModel.addRow(new Object[]{Active, ruleTxt, Class});
      	}
      }
     
     public void SetBottleneckInfo(String Class, String Method, Double Weight){
    	 javax.swing.table.DefaultTableModel bottleTableModel = fv.getBottleNeckModel();
    	 if (bottleTableModel != null) {
    		 bottleTableModel.addRow(new Object[]{Class, Method, Weight});
    	 }
     }
     
     public void getProfileInfo(){
    	 for(int i=0;i<fv.profileTable.getRowCount();i++)
    	 {
    		 LinkedList profileTable = new LinkedList();
    		 profileTable.add(i, fv.profileTable.getValueAt(i,5));
    		 System.out.print(fv.profileTable.getValueAt(i,5));
    		 
    	 }
     }
   
     
     public void statsDisplay()
     {
    	/*String output =  new String();
       	testerforGUI tfg =  new testerforGUI();
    	output = tfg.getData();
    	System.out.println(output);
    	return output;*/
    	 try{
    		
    		//methods
    		fv.methodValue.setText(String.valueOf(fv.getAnalyzer().GetMethods()));
    		
    		//classes
    		fv.classValue.setText(String.valueOf(fv.getAnalyzer().getClasses().size()));
    		
    		//invocations-times
    		fv.executionValue.setText(String.valueOf(fv.getAnalyzer().GetInvocations()));
    		
    		//attributes
    		fv.attributesValue.setText(String.valueOf(fv.getAnalyzer().GetAttributes()));
    		
    		//datalength kb of data transferred
    		fv.dataTransfered.setText(String.valueOf(fv.getAnalyzer().GetDatalen()));
    		
    		//%data unused
    		int clusteredProfiles = fv.getAnalyzer().ClusteredProfileTable.size();
    		int totalProfiles = fv.getAnalyzer().GetTotalProfiles();
    		int unusedData = (totalProfiles != 0) ? (totalProfiles-clusteredProfiles)/totalProfiles : 0;
    		fv.usedInputValue.setText(String.valueOf(unusedData));
    		
    	/*	//runs
    		int runs = pParser.getImsRuns().size();
    		fv.jLabel9.setText(String.valueOf(runs));    		
    		ForePostRuleClassifier classifier = new ForePostRuleClassifier();
    		
    		//rules learnt
    		int rules=classifier.ruleset.size();
    		fv.jLabel23.setText(String.valueOf(rules));
    		
    		//inputs used
    		int inputUsed = classifier.data.numInstances();
    		fv.jLabel22.setText(String.valueOf(inputUsed));
    		
    		//rules unleart
    		int rulesUnlearnt = rc.rulesRipped;
    		fv.jLabel24.setText(String.valueOf(rulesUnlearnt));
    		
    		//inputs used for the rules unlearnt
    		int inputs = rc.data.numInstances();
    		fv.jLabel28.setText(String.valueOf(inputs));
    		
    		//display the rules in the rules table
            
    	    //fv.jTable1.setColumnModel(columnModel);
    		TableModel m = new TableModel();
    		fv.jTable1.setModel(new javax.swing.table.DefaultTableModel(
                   m.rules, m.colName
                    ));
    	    */
    	   
    		
    		    		 
    	 }
    	 catch(Exception e)
    	 {
    		 e.printStackTrace();
    	 }
    	 
    	 
    	 
    	
     }
     
     
}