package org.apache.jmeter;

import java.io.File;
import java.lang.reflect.Method;

import com.accenture.techlabs.assist.jpetstore.ForePostAnalyzerScript;
import com.accenture.techlabs.assist.jpetstore.ProfileRepStartupScript;
import com.accenture.techlabs.assist.profile.ProfRepository;

public class MyDriver extends Thread{
	private static String jmDir;
	static {
		jmDir = System.getProperty("jmeter.home","C:\\Research\\jakarta-jmeter-2.4\\");// Allow override $NON-NLS-1$ $NON-NLS-2$
	}
	
	public void run()
	{
		try
		{
		if (!ProfRepository.started()) {
			   ProfRepository.start();
			   //ProfRepository.startLoopTag(2);
			   //sleep to wait for websphere to start
			   do{
			    sleep(10);
			   } while (!ProfRepository.profilerActive());
			   sleep(40);
			  }
		else
				wait(500);
		}
		catch(Exception e)
		{
			System.out.println("Exception in JMeterScript");
			e.printStackTrace();
		}
		String[] arguments = {"-n"};
    	ProfileRepStartupScript.startup();
        //Thread.currentThread().setContextClassLoader(loader);
        if (System.getProperty("log4j.configuration") == null) {// $NON-NLS-1$ $NON-NLS-2$
            File conf = new File(jmDir, "bin" + File.separator + "log4j.conf");// $NON-NLS-1$ $NON-NLS-2$
            System.setProperty("log4j.configuration", "file:" + conf);
        }
        try {
            JMeter driver = new JMeter();
            driver.start(arguments);
            ForePostAnalyzerScript.startup();
            //
        } catch(Throwable e){
            e.printStackTrace();
            System.err.println("JMeter home directory was detected as: "+jmDir);
        }
	}
	 public static void main(String[] args) {
		 Runnable mydriver = new MyDriver();
		 Thread t = new Thread(mydriver);
		 
	    	
	    }
}
