package com.accenture.techlabs.assist.jpetstore;


import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Random;

import org.apache.jmeter.NewDriver;
import org.apache.jmeter.config.Argument;
import org.apache.jmeter.config.Arguments;
import org.apache.jmeter.control.LoopController;
import org.apache.jmeter.protocol.http.sampler.HTTPSampler;
import org.apache.jmeter.protocol.http.sampler.HTTPSamplerBase;
import org.apache.jmeter.protocol.http.control.CookieManager; 
import org.apache.jmeter.protocol.http.control.Cookie; 
import org.apache.jmeter.protocol.http.util.HTTPArgument;
import org.apache.jmeter.save.ScriptWrapper;
import org.apache.jmeter.testelement.TestPlan;
import org.apache.jorphan.collections.ListedHashTree;

import org.apache.jmeter.threads.AbstractThreadGroup;
import org.apache.jmeter.threads.ThreadGroup;
import org.apache.log4j.Logger;

import com.accenture.techlabs.assist.profile.ProfRepository;

import forepost.utilities.Rule;
import forepost.utilities.Rules;
import forepost.utilities.Term;

public class JMXLoadScript {
  public static CookieManager cookieManager= new CookieManager();
  private static String[] ItemId;
  private static String[] Categories;
  private static String[] ProductId;
  private static String[] URLS;
  private static HashMap URLGetMap;
  private static HashMap URLPostMap;
  private static String[][] SignOnData;
  private static String[][] RetrieveBacklogHourEntries;
  private static String[][] NewAcctData;
  private static String[][] EditAcctData;
  private static String[][] NewOrderData;
  private static int emptymark, getmark;
  private static boolean login;
  private static HashMap inputURLMap = new HashMap();
  private static HashMap rulecountMap = new HashMap();
  private static int rule_count;
  private static String rule_name;
  private static Term.RELOPERATION rop;
  private static final Logger logger = Logger.getLogger(NewDriver.class); // QI
  

  static {
    cookieManager.setClearEachIteration(false);
    //Cookie cookie = new Cookie("toto","titi","localhost","/",false,0);
        //cookieManager.add(cookie);
    getmark = 1;
    URLS = new String[]{
    		"/Agilefant/help.action",
    		"/Agilefant",
    		"/Agilefant/login.jsp",
    		"/Agilefant/dailyWork.action",
    		"/Agilefant/ajax/menuData.action",
    		"/Agilefant/ajax/productChooserData.action",
    		"/Agilefant/ajax/userChooserData.action",
    		"/Agilefant/ajax/projectChooserData.action",
    		"/Agilefant/ajax/backlogAndIterationChooserData.action",
    		"/Agilefant/ajax/retrieveAllTeams.action",
    		"/Agilefant/ajax/retrieveAllProducts.action",
    		"/Agilefant/ajax/teamChooserData.action",
    		"/Agilefant/editUser.action",
    		"/Agilefant/listUsers.action",
    		"/Agilefant/listTeams.action",
    		"/Agilefant/accessRights.action",
    		"/Agilefant/systemSettings.action",
    		"/Agilefant/databaseExport.action",
    		"/Agilefant/static/html/help/dailyWorkPopup.html",
    		"/Agilefant/static/html/help/timesheetsPopup.html",
    		"/Agilefant/static/html/help/devPortfolioPopup.html",
    		"/Agilefant/static/html/help/branchMetricsPopup.html",
    		"/Agilefant/selectBacklog.action",
    		"/Agilefant/timesheet.action",
    		"/Agilefant/ajax/retrieveAllProductsWithStandalone.action",
    		"/Agilefant/ajax/projectPortfolioData.action",
    		"/Agilefant/createPortfolio.action",
    		"/Agilefant/ajax/stories.action",
    		"/Agilefant/ajax/iterations.action",
    		"/Agilefant/ajax/projects.action",
    		"/Agilefant/ajax/users.action",
    		"/Agilefant/editProduct.action?productId=5",
    		"/Agilefant/ajax/search.action?term=pro",
    		"/Agilefant/ajax/retrieveUser.action?userId=3",
    		"/Agilefant/editIteration.action?iterationId=7",
    		"/Agilefant/ajax/retrieveBacklogHourEntries.action?parentObjectId=7&limited=true",
    		"/Agilefant/drawCustomIterationBurndown.action?backlogId=7&customBdWidth=1280&customBdHeight=1024&timeZoneOffset=-300",
    		"/Agilefant/ajax/productBacklogView.action?productId=5",
    		"/Agilefant/ajax/dailyWorkData.action?userId=3",
    		"/Agilefant/ajax/iterationData.action?iterationId=7",
    		"/Agilefant/ajax/treeRetrieveStory.action?storyId=3",
    		"/Agilefant/exportIteration.action?iterationId=7",
    		"/Agilefant/ajax/retrieveProduct.action?productId=5",
    		"/Agilefant/ajax/widgets/iterationMetrics.action?objectId=7&widgetId=10",
    		"/Agilefant/ajax/widgets/userLoad.action?objectId=3&widgetId=11",
    		"/Agilefant/ajax/widgets/projectMetrics.action?objectId=6&widgetId=12",
    		"/Agilefant/ajax/widgets/story.action?objectId=3&widgetId=14",
    		"/Agilefant/ajax/retrieveBranchMetrics.action?storyId=3",
    		"/Agilefant/ajax/getStoryHierarchy.action?storyId=3",
    		"/Agilefant/projectPortfolio.action",
    		"/Agilefant/portlets.action?collectionId=512",
    		//post
    		"/Agilefant/j_spring_security_check?j_username=admin&j_password=secret",
    		"/Agilefant/ajax/defaultUserLoad.action?userId=3",
    		"/Agilefant/ajax/isLoginNameUnique.action?loginName=admin",
    		"/Agilefant/storeUserAndRedirect.action?userId=3&user.admin=true&__checkbox_user.admin=true&user.autoassigntoTasks=true&user.autoassigntostories=false&user.markStoryStarted=ask",
    		"/Agilefant/ajax/storeUser.action?userId=3&user.fullName=fname",
    		"/Agilefant/ajax/storeUser.action?userId=3&user.enabled=true",
    		"/Agilefant/ajax/storeUser.action?password1=secret&password2=secret&user.password1=secret&user.password2=secret&userId=6",
    		"/Agilefant/ajax/storeUser.action?userId=3&user.initials=adm",
    		"/Agilefant/ajax/storeUser.action?userId=3&user.email=email@xx.com",
    		"/Agilefant/ajax/storeUser.f?userId=3&user.weekEffort=40",
    		"/Agilefant/ajax/storeUser.action?userId=3&user.recentItemsNumberOfWeeks=20",
    		"/Agilefant/ajax/storeUser.action?userId=3&teamIds=11&teamsChanged=true",
    		"/Agilefant/ajax/iterationAssignments.action?iterationId=7",
    		"/Agilefant/weeklySpentEffort.action?userTimeZone=7&userId=3",
    		"/Agilefant/ajax/addStoryLabels.action?storyId=3&labelNames=label3",
    		"/Agilefant/ajax/storeStory.action?story.name=story&storyId=3&backlogId=6&iteration=7",
    		"/Agilefant/ajax/storeStory.action?story.description=storydes&storyId=3&backlogId=6&iteration=7",
    		"/Agilefant/ajax/storeStory.action?story.userIds=3&usersChanged=true&storyId=3&backlogId=6&iteration=7",
    		"/Agilefant/ajax/storeStory.action?story.iteration=15&storyId=3&backlogId=6&iteration=7",
    		"/Agilefant/ajax/storeStory.action?story.state=STARTED&storyId=3&backlogId=6&iteration=7",
    		"/Agilefant/ajax/storeStory.action?story.storyPoints=14&storyId=3&backlogId=6&iteration=7",
    		"/Agilefant/ajax/storeStory.action?story.storyValue=20&storyId=3&backlogId=6&iteration=7",
    		"/Agilefant/ajax/checkChangeBacklog.action?storyId=3&backlogId=6",
    		"/Agilefant/ajax/storeIteration.action?iteration.backlogSize=20&iterationId=7",
    		"/Agilefant/ajax/storeIteration.action?iteration.baselineLoad=10&iterationId=7",
    		"/Agilefant/ajax/storeIteration.action?iterationassigneeIds%5B0%5D=3&iteration.assigneesChanged=true&assigneeIds=3&assigneesChanged=true&iterationId=7",
    		"/Agilefant/ajax/storeIteration.action?iteration.description=des&iterationId=7",
    		"/Agilefant/ajax/storeIteration.action?iteration.startDate=1389013200000&iterationId=7",
    		"/Agilefant/ajax/storeIteration.action?iteration.endDate=1392246000000&iterationId=7",
    		"/Agilefant/ajax/createReadonlyToken.action?iterationId=7",
    		"/Agilefant/ajax/shareIterationForm.action?IterationId=7&ReadonlyToken=null",
    		"/Agilefant/ajax/unshareIterationForm.action?IterationId=7",
    		"/Agilefant/ajax/clearReadonlyToken.action?IterationId=7",
    		"/Agilefant/ajax/iterationMetrics.action?iterationId=7",
    		"/Agilefant/ajax/storeTask.action?task.name=ss&taskId=2",
    		"/Agilefant/ajax/storeTask.action?task.state=PENDING&taskId=2",
    		"/Agilefant/ajax/storeTask.action?task.effortLeft=2&taskId=2",
    		"/Agilefant/ajax/storeTask.action?task.description=ssssaa&taskId=2",
    		"/Agilefant/ajax/storeTask.action?taskId=2&responsiblesChanged=true&newResponsibles=3",
    		"/Agilefant/ajax/resetOriginalEstimate.action&taskId=2",
    		"/Agilefant/ajax/splitTask.action?original.state=BLOCKED&original.effortLeft=11h&originalTaskId=2&responsibles=3",
    		"/Agilefant/ajax/addToWorkQueue.action?taskId=2",
    		"/Agilefant/ajax/deleteFromWorkQueue.action?taskId=2",
    		"/Agilefant/ajax/getProjectStoryTree.action?storyFilters.states=NOT_STARTED&storyFilters.states=STARTED&storyFilters.states=PENDING&storyFilters.states=BLOCKED&storyFilters.states=IMPLEMENTED&storyFilters.states=DONE&storyFilters.states=DEFERRED&projectId=6",
    		"/Agilefant/ajax/editMultipleStories.action?storyIds=3&state=IMPLEMENTED&labelNames=label3",
    		"/Agilefant/ajax/projectLeafStories.action&objectId=6",
    		"/Agilefant/ajax/projectIterations.action&projectId=6",
    		"/Agilefant/ajax/iterationRowMetrics.action?iterationId=7",
    		"/Agilefant/ajax/storeProject.action?project.name=projectds&projectId=6",
    		"/Agilefant/ajax/storeProject.action?project.startDate=1388926800000&projectId=6",
    		"/Agilefant/ajax/storeProject.action?project.endDate=1400882400000&projectId=6",
    		"/Agilefant/ajax/storeProject.action?project.backlogSize=22&projectId=6",
    		"/Agilefant/ajax/storeProject.action?project.baselineLoad=1&projectId=6",
    		"/Agilefant/ajax/storeProject.action?project.description=newprojdd&projectId=6",
    		"/Agilefant/ajax/storeProject.action?assigneeIds=3&assigneesChanged=true&projectId=6",
    		"/Agilefant/ajax/storeProject.action?project.status=RED&projectId=6",
    		"/Agilefant/ajax/getProductStoryTree.action?storyFilters.states=NOT_STARTED&storyFilters.states=STARTED&storyFilters.states=PENDING&storyFilters.states=BLOCKED&storyFilters.states=IMPLEMENTED&storyFilters.states=DONE&storyFilters.states=DEFERRED&productId=5",
    		"/Agilefant/ajax/storeProduct.action?product.name=product22&productId=5",
    		"/Agilefant/ajax/storeProduct.action?product.description=sqweqs&productId=5",
    		"/Agilefant/ajax/storeProduct.action?teamIds=11&teamsChanged=true&productId=5",
    		"/Agilefant/ajax/storeTeam.action?team.name=team2&teamId=2",
    		"/Agilefant/ajax/storeTeam.action?userIds=3&usersChanged=true&teamId=2",
    		"/Agilefant/ajax/retrieveAllProductsWithStandalone.action",
    		"/Agilefant/generateTree.action?backlogSelectionType=0&interval=NO_INTERVAL&startDate=&endDate=&userIds=3",
    		"/Agilefant/generateTree.action?backlogSelectionType=0&interval=NO_INTERVAL&startDate=2013-08-08+12%3A00&endDate=2014-04-15+12%3A00&userIds=3",
    		"/Agilefant/generateTree.action?backlogSelectionType=0&onlyOngoing=true&interval=THIS_YEAR&startDate=2014-01-01+00%3A00&endDate=2014-12-31+23%3A59&userIds=3",
    		"/Agilefant/generateTree.action?backlogSelectionType=0&onlyOngoing=true&interval=THIS_YEAR&startDate=2014-01-01+00%3A00&endDate=2014-12-31+23%3A59&userIds=3&action%3AgenerateExcel=Export+to+Excel",
    		"/Agilefant/ajax/projectPortfolioData.action",
    		"/Agilefant/ajax/rankProject.action?projectId=6",
    		"/Agilefant/ajax/unrankProject.action?projectId=6"

    };

  
      try {
      BufferedReader in = new BufferedReader(new FileReader("C:\\Research\\workspace_AFOCMS\\JMeterScript\\input.txt"));
      String str=null;
      while((str=in.readLine())!=null) {
        String[] tokens = str.split(",");
        inputURLMap.put(tokens[0].trim(), tokens[1].trim().split("8080")[1]);
      }
      }
      catch(Exception e) {
        e.printStackTrace();
      }
  }
  
  public static final String JMETER_NON_GUI = "JMeter.NonGui";
  
  //static int numberOfLoadTree = 0;
  public static ListedHashTree loadTree(Rules rules) {
    cookieManager.testStarted();
    //numberOfLoadTree ++;
    //logger.info("The index of tree: " + numberOfLoadTree + "\n"); // QI
    ScriptWrapper jmeterTestPlan = new ScriptWrapper();
    jmeterTestPlan.testPlan = new ListedHashTree();
    TestPlan testPlan = new TestPlan();
    String[] args = new String[10];
    try
    {
      testPlan.setFunctionalMode(false);
      testPlan.setSerialized(false);
      ThreadGroup threadGroup = new ThreadGroup();
      LoopController lc = new LoopController();
      lc.setLoops(1);
      lc.setContinueForever(true);
      threadGroup.setSamplerController(lc);
      threadGroup.setNumThreads(1);
      threadGroup.setRampUp(1);
      AbstractThreadGroup.ON_SAMPLE_ERROR = "continue";
      ListedHashTree htree = new ListedHashTree();
      login = false;
      rule_count = 0;
      rule_name = null;
      rop = null;
      if(rules != null) {
        for(Iterator iter = rules.iterator(); iter.hasNext();){
          Rule rule = (Rule)iter.next();
          if(rule.GetRuleClass().equalsIgnoreCase("Bad")) {
            for(int i = 0; i<rule.getTerms().size();i++) {
              Term term = rule.getTerms().get(i);
              rule_name = term.getInputName();
              rule_count  = term.getIntValue();
              rop = term.getRop();
              if(rop == Term.RELOPERATION.GREATER || rop == Term.RELOPERATION.GEQ) {
                if(rulecountMap.containsKey(rule_name))
                {
                  if(Integer.parseInt(rulecountMap.get(rule_name).toString()) > rule_count)
                  rulecountMap.put(rule_name, rule_count);
                }
                else {
                  rulecountMap.put(rule_name,rule_count-1);
                }
              }
              else if(rop == Term.RELOPERATION.LESS || rop == Term.RELOPERATION.LEQ) {
                if(rulecountMap.containsKey(rule_name))
                {
                  if(Integer.parseInt(rulecountMap.get(rule_name).toString()) < rule_count) {
                    rulecountMap.put(rule_name, rule_count);
                  }
                }
                else {
                  rulecountMap.put(rule_name,rule_count+1);
                }
              }
              else if(rop == Term.RELOPERATION.EQUAL ) {
                rulecountMap.put(rule_name,rule_count);
              }
            }
          }
          else {
            for(int i = 0; i<rule.getTerms().size();i++) {
              Term term = rule.getTerms().get(i);
              rule_name = term.getInputName();
              rule_count  = term.getIntValue();
              rop = term.getRop();
              if(rop == Term.RELOPERATION.GREATER || rop == Term.RELOPERATION.GEQ) {
                if(rulecountMap.containsKey(rule_name))
                {
                  if(Integer.parseInt(rulecountMap.get(rule_name).toString()) < rule_count)
                    rulecountMap.put(rule_name, rule_count);
                }
                else {
                  rulecountMap.put(rule_name,rule_count+1);
                }
              }
              else if(rop == Term.RELOPERATION.LESS || rop == Term.RELOPERATION.LEQ) {
                if(rulecountMap.containsKey(rule_name))
                {
                  if(Integer.parseInt(rulecountMap.get(rule_name).toString()) > rule_count) {
                    rulecountMap.put(rule_name, rule_count);
                  }
                }
                else {
                  rulecountMap.put(rule_name,rule_count-1);
                }   
              }
              else if(rop == Term.RELOPERATION.EQUAL ) {
                rulecountMap.put(rule_name,rule_count);
              }
            }
          }
        }
        // modify the value for each rule. Make sure there are only 100 URLs in the tree. QI
        if (rulecountMap.size() != 0) {
          HashMap<String, Integer> exRulecountMap = new HashMap<String, Integer>();
          int sum = 0;
          for(Iterator iter = rulecountMap.keySet().iterator();iter.hasNext();) {
            String rule_name = iter.next().toString();
            int orgNum = Integer.parseInt(rulecountMap.get(rule_name).toString());
            logger.info("number of URLS in the rules:" + orgNum + " \n"); // QI
            sum = sum + orgNum;
            exRulecountMap.put(rule_name, orgNum);
          }
          int size = 0;
          size = exRulecountMap.size();
          int currentIndex = 0;
          int subsum = 0;
          for(Iterator iter = exRulecountMap.keySet().iterator();iter.hasNext();) {
            String rule_name = iter.next().toString();
            currentIndex ++;
            if (size == currentIndex) {
              int exNum = 100 - subsum;
              //int exNum = 80 - subsum;
              exRulecountMap.put(rule_name, exNum);
            }
            else {
              int value = Integer.parseInt(exRulecountMap.get(rule_name).toString());
              int exNum = 100 * value / sum;
              //int exNum = 80 * value / sum;
              exRulecountMap.put(rule_name, exNum);
              subsum = subsum + exNum;
            }
          }
          for(Iterator iter = exRulecountMap.keySet().iterator();iter.hasNext();) {
            Arguments arguments = new Arguments();
            String rule_name = iter.next().toString();
            String path = (String)inputURLMap.get(rule_name);
            if(path.contains("?")) {
              args = path.split("\\?");
              path = args[0];
              String[] totalterms = args[1].split("&");
              for( int k = 0; k < totalterms.length; k++) {
              String[] terms = totalterms[k].split("=");
              Argument argument = new HTTPArgument();
              argument.setMetaData("=");
              argument.setName(terms[0]);
              argument.setValue(terms[1]);
              arguments.addArgument(argument);
              }
            }
            int j = 0;
            do {
              if (j == 0)
                htree.add(createHttpSampler("/Agilefant/j_spring_security_check?j_username=admin&j_password=secret",null,htree));
              else
                htree.add(createHttpSampler(path,arguments,htree));
              j++;
            }while( j != Integer.parseInt(exRulecountMap.get(rule_name).toString()));
            logger.info(j + " URLS from rules:" + rule_name + "are added into the tree! \n"); // QI
          }
          //int randomCount = 0;
          //for (int indexRandom = 0; indexRandom < 20; indexRandom ++) {
          //  htree.add(createHttpSampler(null,null,htree));// add 20 random URLs
          //  randomCount++;
          //}
          //logger.info( randomCount + " random URLs are added into the tree! \n"); //QI
        }
      /* The previous codes. QI
       * Arguments arguments = new Arguments();
      String rule_name = iter.next().toString();
      String path = (String)inputURLMap.get(rule_name);
      if(path.contains("?")) {
        args = path.split("\\?");
        path = args[0];
        String[] totalterms = args[1].split("&");
        for( int k = 0; k < totalterms.length; k++) {
        String[] terms = totalterms[k].split("=");
        Argument argument = new HTTPArgument();
        argument.setMetaData("=");
        argument.setName(terms[0]);
        argument.setValue(terms[1]);
        arguments.addArgument(argument);
        }
      }
      int j = 0;
      do {
        htree.add(createHttpSampler(path,arguments,htree));
        j++;
      }while( j != Integer.parseInt(rulecountMap.get(rule_name).toString()));
      logger.info("number of URLS from rules:" + j + "\n"); // QI
      */
        else {
          for (int i=0; i < 100; i++) {
            if (i == 0)
              htree.add(createHttpSampler("/Agilefant/j_spring_security_check?j_username=admin&j_password=secret",null,htree));
            else
              htree.add(createHttpSampler(null,null,htree));
          }
          logger.info("number of URLS when the rulemapsize = 0: 100" + "\n"); // QI
        }
      }
      else {
        for (int i=0; i < 100; i++) {
          if (i == 0)
            htree.add(createHttpSampler("/Agilefant/j_spring_security_check?j_username=admin&j_password=secret",null,htree));
          else
            htree.add(createHttpSampler(null,null,htree));
        }
        logger.info("number of URLS when there is no rule: 100" + "\n"); // QI
      /*Iterator iter3 = htree.entrySet().iterator();
      while (iter3.hasNext()) 
      {
        Map.Entry entry3 = (Map.Entry)iter3.next();
        //String key = (String) entry.getKey();
        //Double value = (Double) entry.getValue();
        logger.info(entry3.getValue().toString() );
        logger.info( "\n");
      }*/
      }
      htree.add(cookieManager);
      ListedHashTree htree1 = new ListedHashTree();
      System.out.println("htree size: " + htree.size() + "\n");
//      System.out.println(htree);
      htree1.add(threadGroup,htree);
      System.out.println("htree1 size: " + htree1.size() + "\n");
      jmeterTestPlan.testPlan.add(testPlan,htree1);
      System.out.println("testPlan size: " + jmeterTestPlan.testPlan.size() + "\n");
      logger.info("Add the ListedHashTree and threadgroup into the TestPlan. \n"); // QI
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    finally {
      return (ListedHashTree) jmeterTestPlan.testPlan;
    }
  }
  
  private static HTTPSampler createHttpSampler(String path, Arguments arguments, ListedHashTree htree) {
    String[] args=null;
    Random random = new Random();
    HTTPSampler sampler = new HTTPSampler();
    sampler.setDomain("localhost");
    sampler.setPort(8080);
    if(path==null) {
      path = URLS[random.nextInt(URLS.length)];
      if(rop == Term.RELOPERATION.LEQ || rop == Term.RELOPERATION.LESS || rop == Term.RELOPERATION.EQUAL) {
        while(inputURLMap.get(rule_name).toString().contains(path)) {
          path = URLS[URLS.length];
        }
      }
    }
    int ndx=0;
    for (int i = 0; i < URLS.length; i++){
      if (URLS[i].contains(path)){
        ndx = i;
        break;
      }
    }

    //System.out.println("cookie "+cookieManager.getCookies()+cookieManager.getClearEachIteration());
    String[] tmp = path.split("\\?");
    sampler.setPath(tmp[0]);
    sampler.setFollowRedirects(true);
    sampler.setAutoRedirects(false);
    sampler.setUseKeepAlive(true);
    HTTPSamplerBase.DO_MULTIPART_POST = "false";
    sampler.setMonitor(false);
    sampler.setArguments(createArguments(path,true));
    if (ndx < 51)
      sampler.setMethod("GET");
    else
      sampler.setMethod("POST");

    return sampler;
  }
  
  private static Arguments createArguments(String path,boolean isGetReq){
    Arguments arguments = new Arguments();
    if(path.contains("?")) {
      String[] args = path.split("\\?");
      path = args[0];
      String[] totalterms = args[1].split("&");
      for( int k = 0; k < totalterms.length; k++) {
        String[] terms = totalterms[k].split("=");
        Argument argument = new HTTPArgument();
        argument.setMetaData("=");
        argument.setName(terms[0]);
        if (terms.length < 2)
          argument.setValue("");
        else
          argument.setValue(terms[1]);
        arguments.addArgument(argument);
      }
    }
    return arguments;      
  }
  
}

            