package forepost;
import java.util.ArrayList;
import java.util.Hashtable;

public abstract class KVDataParser {
	protected ArrayList<Hashtable<String, String>> Runs = new ArrayList<Hashtable<String, String>>(); 

	protected Hashtable<String, String> Table = null;
//	protected ArrayList<String> Values = null;
	protected NewArffManager dam = null;
	
	public KVDataParser(){
//		Values = new ArrayList<String>();
	}
	
	abstract public void Parse(String Data) throws Exception;
	
	public void setDam(NewArffManager dam) {
		this.dam = dam;
	}

	public ArrayList<Hashtable<String, String>> getRuns() {
		return Runs;
	}

	protected void AddUniqueKeyValue( String key, String val ) throws Exception
	{
		if( dam == null ) throw new Exception("ARFF manager object is null");
		try {
			if( key != null && key.toLowerCase().endsWith("unselected") ){
				key = key.toLowerCase();
				int ind = key.indexOf("unselected");
				key = key.substring(0, ind);
			}
			dam.AddUniqueKeyValue(key, val);
		} catch (Exception e) {
			e.printStackTrace();
			throw new Exception(e);
		}
	}
	
	protected void AddScreenInputValueMap( String screen, String input, String value ) throws Exception
	{
		//dam.AddScreenInputValueMap(screen, input, value);
	}

}
